/*
 * Clustions: clustered notions - notion graining.
 * (C) Martin Saturka, http://enduce.tangloid.net/
 * Version 0.92, released under the MIT license.
**/

#ifndef __CLUSTIONS_H__
#define __CLUSTIONS_H__

namespace Enduce {

const int DEFMAXCYCL = 40;

class Clustions {

  public:
    Clustions(void);
    Clustions(double thres);

    bool thresholds(double thres);
    int thresholds(int thlen, double *thres);

    bool setLimits(int maxcycl);
    int getLimits(int limlen, int *limits);

    bool cluster(double *centers, double *datamatrix, int *sizes, int *grains,
      double *simils, int *info);
    bool cluster(double *centers, double *datamatrix, int *sizes, int *grainsneg, int *grainspos,
      double *similsneg, double *similspos, int *info);

  private:
    double evalSimil(double *curvector, double *curcenter, int expcount);

    double m_thres;
    int m_maxcycl;

};

extern Clustions *clu;

}

#endif //__CLUSTIONS_H__


