/*
 * Contifiers: natural aggregation of interval valued pairs.
 * (C) Martin Saturka, http://enduce.tangloid.net/
 * Version 0.92, released under the MIT license.
**/

#ifndef __CONTIFIERS_H__
#define __CONTIFIERS_H__

namespace Enduce {

const int AGGDIRCSCNT = 3;
const int AGGTYPESCNT = 3;

enum aggdircs {CONTIFMUT, CONTIFDIR, CONTIFINV};
enum aggtypes {IMPLMINIMUM, IMPLPRODUCT, IMPLBOLD};

class Contifiers {

  public:
    Contifiers(void);
    Contifiers(double thragg);

    bool thresholds(double thres);
    int thresholds(int thlen, double *thres);
    bool setModes(int aggdirc, int aggtype);
    int getModes(int mdlen, int *modes);

    bool aggregate(int vallen, double *valuesx, double *valuesy, double *results);

  private:
    bool aggMutType0(int vallen, double *valuesx, double *valuesy, double *results);
    bool aggMutType1(int vallen, double *valuesx, double *valuesy, double *results);
    bool aggMutType2(int vallen, double *valuesx, double *valuesy, double *results);

    bool aggDirType0(int vallen, double *valuesx, double *valuesy, double *results);
    bool aggDirType1(int vallen, double *valuesx, double *valuesy, double *results);
    bool aggDirType2(int vallen, double *valuesx, double *valuesy, double *results);

    double m_thragg;

    int m_aggdirc;
    int m_aggtype;

};

extern Contifiers *con;

}

#endif //__CONTIFIERS_H__

