#!/usr/bin/env Rscript

dyn.load(paste("libenduce", .Platform$dynlib.ext, sep=""))
source(paste("rbinds", "clustions.R", sep=.Platform$file.sep))

thresh <- c(0.001)
thresh.set <- clustions.thresholds(thresh)$thr

maxcyc <- 100
maxcyc.set <- clustions.maxcycles(maxcyc)$maxcycles

print(list(settings=paste("threshold: ", thresh.set, ", max cycles: ", maxcyc.set, sep="")))


print("notion-clustering [0, 1]-valued data")

inputdata <- c(0.7, 0.6, 0.2, 0.3, 0.1,
  0.4, 0.0, 0.9, 0.0, 0.7,
  0.8, 0.3, 0.5, 0.6, 0.2,
  0.1, 0.5, 0.4, 0.8, 0.0,
  0.0, 0.0, 0.5, 0.2, 0.9,
  0.6, 0.4, 0.2, 0.4, 0.8)
datacases <- matrix(inputdata, nrow=5, ncol=6, byrow=FALSE)

inicens <- datacases[,1:3]

clustions.cluster(datacases, inicens)
#datacases


print("notion-clustering [-1, 1]-valued data")

inputdata2 <- c(-0.7, 0.6, -0.2, -0.3, 0.1,
  0.4, 0.0, -0.9, 0.0, -0.7,
  0.8, -0.3, 0.5, 0.6, -0.2,
  -0.1, 0.5, -0.4, 0.8, 0.0,
  0.0, 0.0, 0.5, -0.2, -0.9,
  -0.6, 0.4, -0.2, 0.4, 0.8)
datacases2 <- matrix(inputdata2, nrow=5, ncol=6, byrow=FALSE)

inicens2neg <- -1 * datacases2[,1:3]
inicens2neg[0.0 > inicens2neg] <- 0.0
inicens2pos <- datacases2[,1:3]
inicens2pos[0.0 > inicens2pos] <- 0.0
inicens2 <- cbind(inicens2neg, inicens2pos)

clustions.cluster2(datacases2, inicens2)
#datacases2


