#!/usr/bin/env Rscript

dyn.load(paste("libenduce", .Platform$dynlib.ext, sep=""))
source(paste("rbinds", "dinorms.R", sep=.Platform$file.sep))

vect <- c(0.1, 0.5, 0.2, -0.3)

thresh <- c(0.001, 0.001)
thresh.set <- dinorms.thresholds(thresh)$thr


types <- c("cop", "sub")
types.set <- dinorms.modes(types)

print(list(settings=paste("threshold: ", thresh.set[1], " ", thresh.set[2],  ", addition: ", types.set$add, ", combination: ", types.set$cmb, sep="")))

dinres <- dinorms.aggregate(vect)

if (0 == dinres$state) {
  print("error during aggregator computation")
} else {
  vneg <- dinres$results[1]
  vpos <- dinres$results[2]
  vcmb <- dinres$results[3]
  print(sprintf("results: neg %.2f, pos %.2f, cmb %.2f", vneg, vpos, vcmb))
}


types <- c("cop", "sta")
types.set <- dinorms.modes(types)

print(list(settings=paste("threshold: ", thresh.set[1], " ", thresh.set[2], ", addition: ", types.set$add, ", combination: ", types.set$cmb, sep="")))

dinres <- dinorms.aggregate(vect)

if (0 == dinres$state) {
  print("error during aggregator computation")
} else {
  vneg <- dinres$results[1]
  vpos <- dinres$results[2]
  vcmb <- dinres$results[3]
  print(sprintf("results: neg %.2f, pos %.2f, cmb %.2f", vneg, vpos, vcmb))
}



